!
!  "$Id: fmdot.F,v 1.5 1998/04/15 18:03:31 balay Exp $";
!
!    Fortran kernel for the MDot() vector routine
!
!
      subroutine FortranMDot4(x, y1, y2, y3, y4, n,sum1,sum2,sum3,sum4)
      implicit none
#include "include/finclude/petsc.h"

      Scalar  sum1, sum2, sum3, sum4, x(*), y1(*), y2(*)
      Scalar  y3(*), y4(*)
      integer n

      integer i

      do 10, i=1,n
        sum1 = sum1 + x(i)*PetscConj(y1(i))
        sum2 = sum2 + x(i)*PetscConj(y2(i))
        sum3 = sum3 + x(i)*PetscConj(y3(i))
        sum4 = sum4 + x(i)*PetscConj(y4(i))
 10   continue

      return 
      end

      subroutine FortranMDot3(x, y1, y2, y3, n,sum1,sum2,sum3)
      implicit none
#include "include/finclude/petsc.h"

      Scalar  sum1, sum2, sum3, x(*), y1(*), y2(*), y3(*)
      integer n

      integer i

      do 10, i=1,n
        sum1 = sum1 + x(i)*PetscConj(y1(i))
        sum2 = sum2 + x(i)*PetscConj(y2(i))
        sum3 = sum3 + x(i)*PetscConj(y3(i))
 10   continue

      return 
      end

      subroutine FortranMDot2(x, y1, y2, n,sum1,sum2)
      implicit none
#include "include/finclude/petsc.h"

      Scalar  sum1, sum2, x(*), y1(*), y2(*)
      integer n

      integer i

      do 10, i=1,n
        sum1 = sum1 + x(i)*PetscConj(y1(i))
        sum2 = sum2 + x(i)*PetscConj(y2(i))
 10   continue

      return 
      end


      subroutine FortranMDot1(x, y1, n,sum1)
      implicit none
#include "include/finclude/petsc.h"

      Scalar  sum1, x(*), y1(*)
      integer n

      integer i

      do 10, i=1,n
        sum1 = sum1 + x(i)*PetscConj(y1(i))
 10   continue

      return 
      end
